package jalview.api;

/**
 * prototype abstract controller for a Jalview alignment view
 * @author jimp
 * 
 * All operations should return true if the view has changed as a result of the operation
 * @param <ViewportI>
 *
 */
public interface AlignViewControllerI<ViewportI>
{

  public boolean makeGroupsFromSelection();

  public boolean createGroup();

  public boolean unGroup();

  public boolean deleteGroups();

  public void setViewportAndAlignmentPanel(AlignViewportI viewport, AlignmentViewPanel alignPanel);

  /**
   * Mark columns in the current column selection according to positions of sequence features
   * @param invert - when set, mark all but columns containing given type
   * @param extendCurrent - when set, do not clear existing column selection
   * @param toggle - rather than explicitly set, toggle selection state
   * @param featureType - feature type string
   * @return true if operation affected state
   */
  boolean markColumnsContainingFeatures(boolean invert, boolean extendCurrent, boolean clearColumns, String featureType);

}
